package eu.ztsh.garmin

import com.mapbox.navigation.tripdata.maneuver.model.Maneuver

class ManeuverMapper {

    companion object {

        fun apply(maneuver: Maneuver): State {
            val state = State()
            maneuver.apply {
                this.primary.apply {
                    state.direction = Direction()
                    when (this.type) {
                        "turn" -> {
                            state.direction.outType = OutType.Lane
                            state.direction.roundabout = OutAngle.AsDirection
                        }

                        "roundabout" -> {
                            state.direction.outType = OutType.RightRoundabout
                        }

                        "arrive" -> {
                            state.flag = true
                        }
                    }
                    when (this.modifier) {
                        "right" -> {
                            when (this.type) {
                                "turn" -> state.direction.outAngle = OutAngle.Right
                                "roundabout" -> {
                                    when (this.degrees) {
                                        137.0 -> state.direction.outAngle = OutAngle.EasyRight
                                        180.0 -> state.direction.outAngle = OutAngle.Straight
                                    }
                                }
                            }
                        }

                        "left" -> {
                            when (this.type) {
                                "turn" -> state.direction.outAngle = OutAngle.Left
                            }
                        }
                    }
                }
                this.stepDistance.apply {
                    this.distanceRemaining?.apply {
                        distanceFormatter.formatDistance(distanceRemaining!!).split(" ").apply {
                            // TODO: Send double
                            state.distance = this[0].replace(',', '.').toDouble().toInt()
                            state.unit = when (this[1]) {
                                "m" -> Unit.Metres
                                "km" -> Unit.Kilometres
                                else -> {
                                    Unit.Any
                                }
                            }

                        }
                    }
                }
                this.laneGuidance?.apply {
                    this.allLanes.apply {
                        println()
                    }
                }
            }
            return state
        }

    }

}
